package cn.citycraft.TeleportRandom;

import java.util.Random;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import cn.citycraft.PluginHelper.config.FileConfig;

public class TeleportRandom extends JavaPlugin implements CommandExecutor {
	public FileConfig config;
	public String pluginname;
	public String servername;

	@Override
	public boolean onCommand(final CommandSender sender, final Command cmd, final String string, final String[] args) {
		if (args.length == 1 && args[0].equalsIgnoreCase("reload")) {
			this.onLoad();
			sender.sendMessage(servername + pluginname + config.getMessage("Message.Reload"));
			return true;
		}
		if (sender instanceof Player) {
			final Player p = (Player) sender;
			if (!p.hasPermission("tpr.use")) {
				sender.sendMessage(servername + pluginname + config.getMessage("Message.NoPerm"));
				return true;
			}
			try {
				switch (args.length) {
				case 0:
					RandomTP(0, p);
					break;
				case 1:
					RandomTP(Integer.parseInt(args[0]), p);
					break;
				case 2:
					RandomTP(Integer.parseInt(args[0]), Bukkit.getWorld(args[1]), p);
					break;
				}
			} catch (final Exception e) {
				sender.sendMessage(pluginname + "§c非法的参数或不存在的世界!");
			}
			return true;
		} else {
			sender.sendMessage(pluginname + "§c控制台无法使用此命令!");
		}
		return false;
	}

	@Override
	public void onLoad() {
		config = new FileConfig(this);
		servername = config.getMessage("servername");
		pluginname = config.getMessage("pluginname");
	}

	public void RandomTP(final int limit, final Player p) {
		RandomTP(limit, p.getWorld(), p);
	}

	public void RandomTP(final int limit, final World world, final Player p) {
		final Random rr = new Random();
		int lr = config.getInt("default");
		if (limit == 0) {
			p.sendMessage(pluginname + config.getMessage("Message.default1"));
			p.sendMessage(pluginname + config.getMessage("Message.default2"));
		} else {
			lr = limit;
			final int lrLimit = config.getInt("Limit");
			if (lr > lrLimit) {
				lr = lrLimit;
				p.sendMessage(String.format(pluginname + config.getMessage("Message.Wran"), lrLimit));
			}
		}
		int x = rr.nextInt(lr);
		int z = rr.nextInt(lr);
		final int xf = rr.nextInt(x);
		final int yf = rr.nextInt(z);
		if (xf % 2 != 0) {
			x = -x;
		}
		if (yf % 2 != 0) {
			z = -z;
		}
		final int y = world.getHighestBlockYAt(x, z);
		final Location trl = new Location(world, x, y - 1, z);
		final Material rbm = trl.getBlock().getType();
		final String blockname = rbm.name();
		for (final String protectblock : config.getStringList("ProtectBlock")) {
			if (protectblock.equalsIgnoreCase(blockname)) {
				trl.getBlock().setType(Material.GLASS);
				p.sendMessage(pluginname + config.getMessage("Message.Protect"));
				this.getServer().getScheduler().runTaskLater(this, new Runnable() {
					@Override
					public void run() {
						trl.getBlock().setType(rbm);
					}
				}, 200);
			}
		}
		final Location nrl = new Location(world, x, y + 3, z);
		p.teleport(nrl);
		p.sendMessage(String.format(pluginname + config.getMessage("Message.Tip"), world.getName(), x, y, z));
	}
}
